@echo off

pip install requests

REM Set the desired repository URL
set repository=https://github.com/AUTOMATIC1111/stable-diffusion-webui
REM Set the desired branch name
set branch=master

REM Extract the repository name from the URL
for %%I in ("%repository:/=" "%") do set "repoName=%%~nxI"

echo it will not remove existing folder anymore
echo delete folder manually for fresh install
REM Remove any existing folder with the same repository name
REM if exist "%repoName%" (
REM    echo Removing existing folder "%repoName%"
REM    rd /s /q "%repoName%"
REM )

REM Clone the repository with the desired branch into the current directory
git clone -b %branch% %repository% "%repoName%"

REM Set the desired command line arguments
REM set commandLineArgs=--xformers --no-half-vae
set commandLineArgs=--xformers

REM Modify the webui-user.bat file
set "filePath=%repoName%\webui-user.bat"

REM Check if the file exists
if exist "%filePath%" (
    echo Modifying "%filePath%"
    (for /f "usebackq delims=" %%L in ("%filePath%") do (
        set "line=%%L"
        if "%%L"=="set COMMANDLINE_ARGS=" (
            echo set COMMANDLINE_ARGS=%commandLineArgs%
        ) else (
            echo %%L
        )
    )) > "%filePath%.tmp"
    move /y "%filePath%.tmp" "%filePath%" > nul
)

python download_models.py

REM Start the webui-user.bat file
cd "%repoName%"
call webui-user.bat

REM Exit the batch file
exit